% clicn.m
% fd, iacs, mai, juillet 2004, 2, 9 janvier  2005, 25 fevrier 2025
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  xlabel ('Integration de dx/dt + y = 0,  dy/dt - x = 0 par le schema de Crank Nicolson'); 
title ('Cnam Paris. Travaux pratiques Iacs.') ;
n=32 ; 
dt=2*pi/n
t=zeros(n+1,1);
x=zeros(n+1,1);
y=zeros(n+1,1);
xex=zeros(n+1,1); yex=zeros(n+1,1);
xex(1:1)=1; yex(1:1)=0;
x(1:1)=xex(1:1); y(1:1)=yex(1:1);
t(1:1)=0; 
%          boucle en temps
for i=1:n;
t(i+1)=t(i)+dt;
x(i+1)= ( (1-(dt/2)**2)*x(i) - dt * y(i)) / (1+(dt*dt)/4);
y(i+1)= (dt*x(i) +  (1-(dt/2)**2)*y(i)) / (1+(dt*dt)/4);
xex(i+1)=cos(t(i+1)) ; yex(i+1)=sin(t(i+1)) ;
end ;

tempsfinal = t(n+1:n+1)

plot(xex(:,1),yex(:,1), 'b;cercle exact;',   x(:,1),y(:,1),'*;trajectoire numerique;') 
axis ([ -1.2  1.2 -1.2  1.2 ]) 
  title('Crank-Nicolson : ordre 2')
print -dpdf 14-clicn.pdf
print -djpg 14-clicn.jpg

