% clihe.m
% fd, iacs, mai, 08 juillet 2004, 2 janvier  2005, 25 fevrier 2025 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('clihe. Integration de dx/dt + y = 0,  dy/dt - x = 0 par le schema de Heun d ordre 2') 
% title ('Cnam Paris. Travaux pratiques Iacs.') ;
%  n=10;
n=32 ; 
dt=2*pi/n
t=zeros(n+1,1);
x=zeros(n+1,1);
y=zeros(n+1,1);
xi=zeros(n+1,1);
yi=zeros(n+1,1);
xex=zeros(n+1,1); yex=zeros(n+1,1);
xex(1:1)=1; yex(1:1)=0;
x(1:1)=xex(1:1); y(1:1)=yex(1:1);
t(1:1)=0;

%          boucle en temps
for i=1:n;
t(i+1)=t(i)+dt;
xi(i)=x(i) - dt * y(i);
yi(i)=y(i) + dt * x(i);
x(i+1)=x(i) - 0.5 * dt * ( y(i) + yi(i) ) ;
y(i+1)=y(i) + 0.5 * dt * ( x(i) + xi(i) ) ;
xex(i+1)=cos(t(i+1)) ; yex(i+1)=sin(t(i+1)) ;
end ;


tempsfinal = t(n+1:n+1)
plot(xex(:,1),yex(:,1), 'b;cercle exact;',   x(:,1),y(:,1),'*;trajectoire numerique;') 
axis ([ -1.2  1.2 -1.2  1.2 ]) 
  title('Heun : ordre 2')
print -dpdf 15-clihe.pdf
print -djpg 15-clihe.jpg


