% pcliee.m
% fd, iacs, mai, juillet 2004, 2, 9 janvier  2005, 25 fevrier 2025
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('pcliee. Cycle limite ; precision du schema d Euler explicite') ;
% title ('Cnam Paris. Travaux pratiques Iacs.') ;
m=8 
pas=zeros(m,1);
err=zeros(m,1);
%
n=64 ; 
for j=1:m;
t=zeros(n+1,1); x=zeros(n+1,1); y=zeros(n+1,1);
t(1:1)=0; x(1:1)=1; y(1:1)=0; dt=2*pi/n;
%          boucle en temps
for i=1:n;
t(i+1)=t(i)+dt;
x(i+1)=x(i) - dt * y(i);
y(i+1)=y(i) + dt * x(i); end ; 
% 
pas(j)=log(n)/log(2);
err(j)=log ( abs(x(n+1,1)-1) +  abs(y(n+1,1))) / log(2) ;
n=2*n; end;

%  calcul du coefficient avec une droite de regression
alpha=codre(m,pas,err)

plot(pas,err(:,1),'*;logarithme des ereurs;') ; 
axis ([ 5.8   13.2      -9.1     -1.1 ])  
title('cycle limite       Euler explicite : ordre 1')
print -dpdf 17-pcliee.pdf
print -djpg 18-pcliee.jpg



