% clirk.m
% Cycle LImite avec le Runge Kutta
% integration de dx/dt + y = 0,  dy/dt - x = 0 
%                              par LE Runge Kutta d ordre 4
% fd, iacs, mai, 14 septembre 2004, 2, 9 janvier 2005
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('clirk. Iintegration de dx/dt + y = 0,  dy/dt - x = 0 \
par LE Runge Kutta d ordre 4')
% title ('Cnam Paris. Travaux pratiques Iacs.') ;
n=8 ;  dt=2*pi/n;
t=zeros(n+1,1);
x=zeros(n+1,1);   y=zeros(n+1,1);
px1=zeros(n+1,1); py1=zeros(n+1,1);
px2=zeros(n+1,1); py2=zeros(n+1,1);
px3=zeros(n+1,1); py3=zeros(n+1,1);
px4=zeros(n+1,1); py4=zeros(n+1,1);
xex=zeros(n+1,1); yex=zeros(n+1,1);
xex(1:1)=1; yex(1:1)=0;
x(1:1)=xex(1:1); y(1:1)=yex(1:1);
t(1:1)=0;
%          affichage du point initial
vec1=x(1:1) ;  vec2=y(1:1) ; 
% gset yrange[-1.2:1.2] ; gset xrange[-1.2: 1.2] ; 
axis ([ -1.2 ,  1.2 ,  -1.2 , 1.2 ]) ; 
hold off ; plot ( vec1, vec2, '*;trajectoire;') ; 
%          boucle en temps
  for i=1:n;
t(i+1)=t(i)+dt;
px1(i) = - y(i)                         ; py1(i) = x(i) ; 
px2(i) = -( y(i) + 0.5 * dt * py1(i) )  ; py2(i) = ( x(i) + 0.5 * dt * px1(i) ) ; 
px3(i) = -( y(i) + 0.5 * dt * py2(i) )  ; py3(i) = ( x(i) + 0.5 * dt * px2(i) ) ; 
px4(i) = -( y(i) + dt * py3(i) )  ;       py4(i) = ( x(i) + dt * px3(i) ) ; 
x(i+1)  = x(i) + dt * ( px1(i) + 2*px2(i) + 2*px3(i)+ px4(i)  ) / 6 ;
y(i+1)  = y(i) + dt * ( py1(i) + 2*py2(i) + 2*py3(i)+ py4(i)  ) / 6 ;
xex(i+1)=cos(t(i+1)) ; yex(i+1)=sin(t(i+1)) ;  
% affichage du point courant
vec1=x(i+1) ;  vec2=y(i+1) ; 
hold on ; plot ( vec1, vec2, '*r;;') ;
end ;
 plot ( xex(:,1),yex(:,1), 'b;cercle exact;') ; hold off ;
un = x(n+1)
nul = y(n+1)
