% reqrk.m
% fd, iacs, mai, 08 juillet 2004, 2, 9 janvier 2005, 25 fevrier 2025 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel ('reqrk. Integration de du/dt + u = 0 par LE schema de Runge-Kutta d ordre 4') 
% title ('Cnam Paris. Travaux pratiques Iacs.') ;
  n=3;
dt=1/n 
t=zeros(n+1,1);
u=zeros(n+1,1);
p1=zeros(n+1,1);
p2=zeros(n+1,1);
p3=zeros(n+1,1);
p4=zeros(n+1,1);
uex=zeros(n+1,1);
uex(1:1)=1;
u(1:1)=uex(1:1);
t(1:1)=0;
  for i=1:n;
t(i+1)=t(i)+dt;
p1(i) = - u(i);
p2(i) = - ( u(i) + 0.5 * dt * p1(i) ) ;
p3(i) = - ( u(i) + 0.5 * dt * p2(i) ) ;
p4(i) = - ( u(i) + dt * p3(i) ) ;
u(i+1)  = u(i) + dt * ( p1(i) + 2*p2(i) + 2*p3(i)+ p4(i)  ) / 6 ;
uex(i+1)=exp(-t(i+1));
end ;


temps_final = t(n+1:n+1) 
plot( t,uex(:,1), 'b;solution exacte;' , t,u(:,1),'*;trajectoire numerique;', t,u(:,1),'k;;', t,uex(:,1)) ; 
axis ([ -.01   1.01   .3   1.05]) ;
title('integration de du/dt + u = 0 par le schema de Runge-Kutta d ordre 4')
print -dpdf 06-reqrk.pdf
print -djpg 06-reqrk.jpg


